﻿Public Class fMain

    Private Pages() As Object
    Private ImageCount As Integer
    Private CurrentImage As Integer

    Private Sub fMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        cmdScan.Enabled = True
        cmdLoad.Enabled = True
        cmdSave.Enabled = False

        cmdRotate90.Enabled = False
        cmdRotate180.Enabled = False
        cmdRotate270.Enabled = False
        cmdCrop.Enabled = False
        cmdDespeckle.Enabled = False

        cmdPrev.Enabled = False
        cmdNext.Enabled = False

        AxImageBox1.AutoZoom = True
        AxImageBox1.ScaleToGray = True

        ImageCount = 0

    End Sub

    Private Sub cmdCrop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCrop.Click

        AxImageBox1.MouseSelectRectangle()
        AxImageBox1.CropToSelection()
        Pages(CurrentImage) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)

    End Sub

    Private Sub cmdDespeckle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDespeckle.Click

        AxImageBox1.Despeckle()
        Pages(CurrentImage) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)

    End Sub

    Private Sub cmdLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdLoad.Click

        Dim i As Integer

        AxImageBox1.ReadImageNumber = 1
        AxImageBox1.LoadDialog()

        ReDim Pages(1)
        Pages(1) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)
        ImageCount = AxImageBox1.ImageCount(AxImageBox1.LastFileName)
        If ImageCount > 1 Then
            ReDim Preserve Pages(ImageCount)
            For i = 2 To ImageCount
                AxImageBox1.ReadImageNumber = i
                AxImageBox1.LoadFromFile(AxImageBox1.LastFileName)
                Pages(i) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)
                lblPageNumText.Text = "Loading - Page " & i & " of " & ImageCount
                Me.Refresh()
            Next i
        End If

        CurrentImage = 1
        AxImageBox1.ReadBinary2(Pages(CurrentImage))
        lblPageNumText.Text = "Page " & CurrentImage & " of " & ImageCount

        If ImageCount > 0 Then

            cmdSave.Enabled = True
            cmdRotate90.Enabled = True
            cmdRotate180.Enabled = True
            cmdRotate270.Enabled = True
            cmdCrop.Enabled = True
            cmdDespeckle.Enabled = True

            If ImageCount > 1 Then
                cmdPrev.Enabled = True
                cmdNext.Enabled = True
            Else
                cmdPrev.Enabled = False
                cmdNext.Enabled = False
            End If

        End If

    End Sub

    Private Sub cmdNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdNext.Click

        If CurrentImage < ImageCount Then
            CurrentImage = CurrentImage + 1
            AxImageBox1.ReadBinary2(Pages(CurrentImage))
            lblPageNumText.Text = "Page " & CurrentImage & " of " & ImageCount
        End If

    End Sub

    Private Sub cmdPrev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPrev.Click

        If CurrentImage > 1 Then
            CurrentImage = CurrentImage - 1
            AxImageBox1.ReadBinary2(Pages(CurrentImage))
            lblPageNumText.Text = "Page " & CurrentImage & " of " & ImageCount
        End If

    End Sub

    Private Sub cmdRotate180_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRotate180.Click

        AxImageBox1.Rotate(180.0)
        Pages(CurrentImage) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)

    End Sub

    Private Sub cmdRotate270_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRotate270.Click

        AxImageBox1.Rotate(270.0)
        Pages(CurrentImage) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)

    End Sub

    Private Sub cmdRotate90_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRotate90.Click

        AxImageBox1.Rotate(90.0)
        Pages(CurrentImage) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)

    End Sub

    Private Sub cmdSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSave.Click

        Dim i As Integer

        For i = 1 To ImageCount
            AxImageBox1.ReadBinary2(Pages(i))
            lblPageNumText.Text = "Saving - Page " & CurrentImage & " of " & ImageCount
            If AxImageBox1.ColorFormat = csXImageTrial.TxColorFormat.cfMonoBW Then
                AxImageBox1.Compression = csXImageTrial.TxCompression.cmGroup4
            Else
                AxImageBox1.Compression = csXImageTrial.TxCompression.cmNone
            End If
            AxImageBox1.AddToTIF(0)
        Next i

        AxImageBox1.WriteTIFDialog()
        AxImageBox1.ReadBinary2(Pages(CurrentImage))
        lblPageNumText.Text = "Page " & CurrentImage & " of " & ImageCount

    End Sub

    Private Sub cmdScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdScan.Click

        AxImageBox1.SelectTwainDevice()
        AxImageBox1.TwainMultiImage = True
        AxImageBox1.UseADF = True
        ImageCount = 0
        AxImageBox1.Acquire()

        CurrentImage = 1
        AxImageBox1.ReadBinary2(Pages(CurrentImage))
        lblPageNumText.Text = "Page " & CurrentImage & " of " & ImageCount

        If ImageCount > 0 Then

            cmdSave.Enabled = True
            cmdRotate90.Enabled = True
            cmdRotate180.Enabled = True
            cmdRotate270.Enabled = True
            cmdCrop.Enabled = True
            cmdDespeckle.Enabled = True

            If ImageCount > 1 Then
                cmdPrev.Enabled = True
                cmdNext.Enabled = True
            Else
                cmdPrev.Enabled = False
                cmdNext.Enabled = False
            End If

        End If

    End Sub

    Private Sub AxImageBox1_OnAcquire(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AxImageBox1.OnAcquire

        ImageCount = ImageCount + 1
        ReDim Preserve Pages(ImageCount)
        Pages(ImageCount) = AxImageBox1.WriteBinary(csXImageTrial.TxGraphicsFormat.gfBMP)
        lblPageNumText.Text = "Acquiring - Page " & CurrentImage & " of " & ImageCount

    End Sub
End Class
